<?php
  /*
   Küchenbetreuer:
   E-Mail-Adresse für Kopie
   Telefonnr für Rückfragen:
   Abholung am:
   Abholung um Uhrzeit:

   - Ordersatz auswählen || neuen Ordersatz erstellen || Ordersatz kopieren
   - Ordersatz abschließen = PDF-Datei erzeugen, archivieren, per Mail, per Fax
   */

include_once($_SESSION['sys']['basedir'].'masks/metro/utils.php');
include_once($_SESSION['sys']['basedir'].'lib/mail.php');

if (substr($_SERVER["SCRIPT_FILENAME"],-10) == '/index.php' &&
    !empty($_GET['id']))
  $_SESSION['ordersatz'] = $_GET['id'];

$jscode[] = <<<EOC
grid_column_edit[1] = {
    default_menu: false,
    width: '9em',
    values: [
	     ['löschen', '', 0],
	     ['1 mal bestellen', '1', 1],
	     ['2 mal bestellen', '2', 2],
	     ['3 mal bestellen', '3', 3],
	     ['4 mal bestellen', '4', 4],
	     ['5 mal bestellen', '5', 5],
	     ['6 mal bestellen', '6', 6],
	     ['7 mal bestellen', '7', 7],
	     ['8 mal bestellen', '8', 8],
	     ['10 mal bestellen', '10', 10],
	     ['12 mal bestellen', '12', 12],
	     ['14 mal bestellen', '14', 14]
	     ]
};

function build_pdf_callback(data)
{
    info('PDF erstellt');
    window.open('ajax/ajax.php?tmpdir='+data.tmpdir+'&source=metro__ordersatz_pos&func=file&name=download','_blank');
}

function build_pdf()
{
  var source = document.getElementById('source');
  if (!source) return false;

  var parms = 'source=' + source.innerHTML + '&callback=pdf';
  ajax_request('function', parms, build_pdf_callback);
  return false;
}

function finish_callback(data)
{
  if (data.status == true) {
    info('Ordersatz verschickt');

    confirm("Der Ordersatz wurde verschickt.");
    window.location.href = './?mask=metro__ordersatz';
  }
}

function finish()
{
  var source = document.getElementById('source');
  if (!source) return false;

  var parms = 'source=' + source.innerHTML + '&callback=send';
  ajax_request('function', parms, finish_callback);
  return false;
}

EOC;

$buttons = <<<EOC
<p style="margin-top: 0px; margin-bottom: 4px; text-align: center;">
<button onclick="return build_pdf()">PDF erstellen</button>
&nbsp;
<button onclick="return finish()">Abschließen</button>
<br>Bei Abschluß wird ein Fax zu Metro und eine Kopie per Mail an den Koch geschickt.
</p>
EOC;

function get_title($id)
{
  global $db;

  $query = sprintf('SELECT name FROM metro_ordersatz WHERE id = %d', $id);
  $sth = $db->query($query);
  $row = $sth->fetch();
  if ($row) return 'Ordersatz für ' . $row['name'];
  else return 'Unbekannter Ordersatz';
}

# INSERT INTO metro_ordersatz_pos (ordersatz,artikel,sys_user,sys_edit) SELECT ORDERID,id,'joey',now() FROM metro_artikel;
# DELETE FROM metro_ordersatz_pos WHERE ordersatz = ORDERID AND anzahl IS NULL
$mask = array(
	      'table' => 'metro_ordersatz',
	      'join' => array('metro_ordersatz_pos ON ordersatz = metro_ordersatz.id',
			      'metro_artikel ON artikel = metro_artikel.id'),
	      'title' => get_title($_SESSION['ordersatz']),
	      'where' => sprintf('ordersatz = %d AND owner = %d AND done IS NULL', $_SESSION['ordersatz'], $_SESSION['sys']['uid']),
	      'list' => array(
			      'id' => array(
					    'name' => 'ID',
					    'sql' => 'metro_artikel.id',
					    'visible' => false,
					    ),
			      'anzahl' => array(
					    'name' => 'Anzahl',
					    'width' => 60,
					    'specs' => "ClassName: 'alignrightpad', filterUI: 't'",
					    ),
			      'artnr' => array(
					    'name' => 'Artnr',
					    'width' => 60,
					    'specs' => "filterUI: 't'",
					    'visible' => false,
					    ),
			      'menge' => array(
					    'name' => 'Menge',
					    'width' => 60,
					    'specs' => "ClassName: 'alignrightpad', filterUI: 't'",
					    ),
			      'bezeichnung' => array(
					    'name' => 'Bezeichnung',
					    'width' => 260,
					    'specs' => "filterUI: 't'",
					    ),
			      'hersteller' => array(
					    'name' => 'Hersteller',
					    'width' => 80,
					    'specs' => "filterUI: 't'",
					    ),
			      'vpe' => array(
					    'name' => 'Einheit',
					    'width' => 70,
					    'specs' => "ClassName: 'aligncenter', filterUI: 's'",
					    'control' => "new Rico.TableColumn.lookup(".grid_lookup_sql('metro_vpe','id','name').", 0, '')",
					    ),
			      'abteilung' => array(
					    'name' => 'Abteilung',
					    'width' => 80,
					    'specs' => "ClassName: 'aligncenter', filterUI: 's'",
					    'control' => "new Rico.TableColumn.lookup(".grid_lookup_sql('metro_abteilung','id','name').", 0, '')",
					    ),
			      'gang' => array(
					    'name' => 'Gang',
					    'width' => 50,
					    'sql' => 'abteilung',
					    'specs' => "ClassName: 'aligncenter', filterUI: 's'",
					    'control' => "new Rico.TableColumn.lookup(".grid_lookup_sql('metro_abteilung','id','gang').", 0, '')",
					    ),
			      ),
	      'edit' => array(
			      'buttons' => array(
					    'type' => 'html',
					    'code' => $buttons,
					    'sql' => false,
					    ),
			      ),
	      'callbacks' => array(
				   'cellsave' => cb_cellsave,
				   'pdf' => cb_pdf,
				   'send' => cb_send,
				),
	      'files' => array(
			       'download' => process_download,
			       ),
	      'buttons' => array(
				 'save' => false,
				 'insert' => false,
				 'delete' => false,
				 ),
	      );

function cb_cellsave()
{
  global $db;

  if ($_POST['value'] == 0)
    $sql = sprintf("UPDATE metro_ordersatz_pos SET anzahl = NULL, sys_user = %s, sys_edit = now() WHERE ordersatz = %d AND artikel = %d",
		   $db->quote($_SESSION['sys']['login']),
		   $_SESSION['ordersatz'], $_POST['id']);
  else
    $sql = sprintf("UPDATE metro_ordersatz_pos SET anzahl = %d, sys_user = %s, sys_edit = now() WHERE ordersatz = %d AND artikel = %d",
		   $_POST['value'], $db->quote($_SESSION['sys']['login']),
		   $_SESSION['ordersatz'], $_POST['id']);

  $sth = $db->query($sql);
}


function cb_pdf()
{
  $tmpdir = mk_tempdir();
  $result = ordersatz_write($_SESSION['ordersatz'], $tmpdir, false);

  if ($result !== true)
    return array('error' => $result);

  return array('tmpdir' => substr($tmpdir,strlen($_SESSION['sys']['basedir'])));
}

function process_download()
{
  if (strpos($_GET['tmpdir'], '..') !== false)
    return false;

  $fname = $_SESSION['sys']['basedir'] . $_GET['tmpdir'] . '/ordersatz.pdf';

  if (!file_exists($fname) || !is_file($fname))
    return 'File not found';

  send_file($fname);
  rm_tempdir($_SESSION['sys']['basedir'] . $_GET['tmpdir']);
}

function cb_send()
{
  $tmpdir = mk_tempdir();
  $result = ordersatz_write($_SESSION['ordersatz'], $tmpdir, true);

  if ($result !== true)
    return array('error' => $result);

  rm_tempdir($tmpdir);

  return array('status' => true);
}

?>
